--------------------------------------------------------
--------------------------------------------------------
----	Project....: LUI NextGenWoWUserInterface    ----
----	Plugin.....: Addon Management               ----
----	Description: LUI Addon Switcher Module      ----
----	Rev Date...: 08/03/2011 (mm/dd/yyyy)        ----
----	Author.....: Kaliad @EU-Runetotem           ----
--------------------------------------------------------
--------------------------------------------------------


--------------------------------------------------------
--- TO DO : Add options for the Modular Addons Management (like rSA, Forte..)
--- TO DO : Quando visualizzo i dettagli di un pack di addon con calcolo della memoria, deve venire l'elenco ordinato per memoria discendente
--- TO DO : 120 : Ottimizzare la ricreazione degli addon di un pacco quando uno viene eliminato...
--- TO DO : 

--------------------------------------------------------
local LUI = LibStub("AceAddon-3.0"):GetAddon("LUI")
local module = LUI:NewModule("Add-ons Manager", "AceEvent-3.0")
local LSM = LibStub("LibSharedMedia-3.0")
local widgetLists = AceGUIWidgetLSMlists
local version = GetAddOnMetadata("LUI_AddonsManager", "Version")
local author = GetAddOnMetadata("LUI_AddonsManager", "Author")

local db
--------------------------------------------------
-- / LOCAL VARIABLES / --
--------------------------------------------------
local _,L = ...
local myPlayerName = UnitName("player")
local myPlayerFaction = UnitFactionGroup("player")
local myPlayerRealm = GetRealmName()
local InfoStats = {}
local defaultMouseBindings = {"NONE", "Mouse1", "Mouse2", "Mouse3", "Mouse4", "Mouse5", 
					"CTRL+Mouse1","CTRL+Mouse2","CTRL+Mouse3","CTRL+Mouse4","CTRL+Mouse5",
					"SHIFT+Mouse1","SHIFT+Mouse2","SHIFT+Mouse3","SHIFT+Mouse4","SHIFT+Mouse5",
					"ALT+Mouse1","ALT+Mouse2","ALT+Mouse3","ALT+Mouse4","ALT+Mouse5",}

local AddonPacks = {}
local AddonPacksArray = {}
local CurrentInstalledAddons = {}
local newAddOnItem = {
	Name = "",
	Title = "",
	Notes = "",
	Version = "",
	Author = "",
	Enabled = false,
	Loadable= false,
	LoD = false,
	Dependencies = "",
	MemoryUsed = 0,
} 
local newAddonPack = {
	Name = "",
	Description = "",
	Binding = defaultMouseBindings[0],
	Enabled = false,
	Addons ={},
	Selected = false,
	MemoryUsage = 0,
	ShowDetails = false,
	Modified = false,
	Loaded = false,
	DBVersion = "",
} 

local profileToCopy = ""
local packToCopy = ""

--------------------------------------------------
-- / LOCAL FUNCTIONS / --
--------------------------------------------------
local function cloneTable(object)
	if type(object) ~= "table" then
		return object
	end

	local clone = {}

	for k, v in pairs(object) do
		clone[k] = cloneTable(v)
	end

	return clone
end
local function Print(message, error)
	local color, errorColor = "|cff33ff00", "|cffff3300"

	if not db.profile.ShowMessages then
		return
	end

	if error then
		color = errorColor
	end

	message = color .. module:GetName() .. ": " .. message .. "|r"

	print(message)
end  --to print an Error Message	
local function formatMem(kb)
			if kb > 1024 then
				return format("%.1fmb", kb / 1024)
			else
				return format("%.1fkb", kb)
			end
		end
function module:ResetDB()

	db.profile.LUIAddons = {} -- Clear all the Addons DB.
	
	-- TODO : refresh the InfoText Data.
	
end -- to clear all the Addons Packs DB.
function module:RefreshPack (pack)
	local modified = false
	-- db.profile.LUIAddons.InstalledAddons contains the update version of the installed Addons.
	-- Check if some Addon got Deleted from the system..
	for i=1,#db.profile.LUIAddons.AddonPacks[pack].Addons do
		local name = db.profile.LUIAddons.AddonPacks[pack].Addons[i]
		if not (self:AddonInstalled(name)) then
			modified = true 
		end
	end
	if modified then
		local array = {}
		for i=1,#db.profile.LUIAddons.AddonPacks[pack].Addons do
			local name = db.profile.LUIAddons.AddonPacks[pack].Addons[i]
			if (self:AddonInstalled(name)) then 
				table.insert(array,name)
			end
		end
		db.profile.LUIAddons.AddonPacks[pack].Addons = array
	end
	-- 1.3 If you install a new Addon, it will be automatically Added and Activated on all Packs.
	-- for k, v in pairs(db.profile.LUIAddons.InstalledAddons) do
		-- if not self:AddonInPack(k,pack) then
			-- table.insert(db.profile.LUIAddons.AddonPacks[pack].Addons, v.Name) 
			-- modified = true
		-- end					
	-- end
	return modified
end -- What to do when an Addon get Deleted or Installed --
function module:AddonInstalled(add) -- Check if Add is a currently installed Addon
	local installedAddon = {}
	local found = false
	for k, v in pairs(CurrentInstalledAddons) do
		if v.Name == add then
			found =  true
			installedAddon = cloneTable(add)
		else
		
		end
	end
	
	return found,installedAddon
end
function module:AddonInPack(add,pack) -- Check if Add is a currently installed Addon
	local addInPack = {}
	local found = false
	for k, v in pairs(db.profile.LUIAddons.AddonPacks[pack].Addons) do
		if v.Name == add then
			found =  true
			addInPack = cloneTable(add)
		else
		
		end
	end
	
	return found,addInPack
end

StaticPopupDialogs["RELOAD_UI_ADDON"] = {
		text = "Activating Add-Ons Pack...\nThe UI needs to be reloaded!",
		button1 = ACCEPT,
		button2 = CANCEL,
		OnAccept = ReloadUI,
		timeout = 0,
		whileDead = 1,
		hideOnEscape = 1
	}
--------------------------------------------------
-- / ADDONS MANAGEMENT FUNCTIONS / --
--------------------------------------------------
local function clearNewAddonItem()
	newAddOnItem = {
		Name = "",
		Title = "",
		Notes = "",
		Version = "",
		Author = "",
		Enabled = false,
		Loadable= false,
		LoD = false,
		Dependencies = "",
		MemoryUsed = 0,
}
end
function module:PacksArray()
	local Array = {}
	if db.profile.LUIAddons.AddonPacks == nil then
			table.insert(Array,"No Addon Packs Created")
	else
			for k, v in pairs(db.profile.LUIAddons.AddonPacks) do
				table.insert(Array,v.Name)
			end 
	end
	if #Array > 0 then
			table.insert(Array,"-")
	end
	table.sort(Array)
	return Array
end
function module:LUIProfiles()
	local Array = {}
	if db.profiles == nil then
			table.insert(p,"No LUI Profiles Avaiable")
	else
		for k, v in pairs(db.profiles) do
			table.insert(Array,k)
		end 
	end
	table.sort(Array)
	return Array

end
function module:LUI_InstalledAddons()
	-- Get all the currently Installed Addons in a local Array (used on Inizialization)
	local Array = {}
	for i=1,GetNumAddOns() do
		local name,title,notes,enabled,loadable,reason,_ = GetAddOnInfo(i) --loadable is : "DISABLED", "MISSING", "INTERFACE_VERSION" --enabled = 1 or nil
		local version = GetAddOnMetadata(name, "Version")
		local author =  GetAddOnMetadata(name, "Author")
		local lod =  GetAddOnMetadata(name, "LoadOnDemand")--IsAddOnLoadOnDemand(i)
		local dep,dep2,dep3 = GetAddOnDependencies(i)
		
		newAddOnItem.Name = name
		newAddOnItem.Title = title
		newAddOnItem.Notes = notes
		newAddOnItem.Author = author
		newAddOnItem.Version = version
		if loadable == nil then newAddOnItem.Loadable = false else newAddOnItem.Loadable= true end
		newAddOnItem.Enabled = false
		if enabled == nil then newAddOnItem.Enabled = false else newAddOnItem.Enabled= true end
		if lod== nil then newAddOnItem.LoD = false else newAddOnItem.LoD = true end
		if dep then newAddOnItem.Dependencies = dep.."." end
		if dep and dep2 then newAddOnItem.Dependencies = dep.. ", "..dep2.."." end
		if dep and dep2 and dep3 then newAddOnItem.Dependencies = dep.. ", "..dep2..", "..dep3.."." end
		
		Array[name]= newAddOnItem -- TODO
		clearNewAddonItem()
		
	end
	return Array
end
function module:LUIPacks(profile)
	-- Get all the Profiles in an array used in the Options' Combo
	local Array = {}
	local p = module:LUIProfiles()
	if p[profile] == nil or db.profiles[p[profile]] == nil then
			table.insert(Array,"Error - No Profile!")
	else
		if db.profiles[p[profile]].LUIAddons.AddonPacks == nil then
			table.insert(Array,"No LUI Addons Packs")
		else
			for k, v in pairs(db.profiles[p[profile]].LUIAddons.AddonPacks) do
				table.insert(Array,v.Name)
			end 	
		end
	end
	table.sort(Array)
	return Array

end
function module:LUIEnableAddon(add)
	EnableAddOn(add.Name)
	
end
function module:LUIDisableAddon(add)
	DisableAddOn(add.Name)
	
end
function module:storeMemoryUsage(pack)
	local mu=0
	collectgarbage("collect")
	UpdateAddOnMemoryUsage()
	if db.profile.LUIAddons.AddonPacks[pack.Name] then
		if db.profile.LUIAddons.AddonPacks[pack.Name].Addons then
			for i=1, #db.profile.LUIAddons.AddonPacks[pack.Name].Addons do
				local name = db.profile.LUIAddons.AddonPacks[pack.Name].Addons[i]
				if (CurrentInstalledAddons[name]) then 
					CurrentInstalledAddons[name].MemoryUsed = GetAddOnMemoryUsage(name)
					mu = mu + CurrentInstalledAddons[name].MemoryUsed
				end
			end
			
			
		end
	end
	db.profile.LUIAddons.AddonPacks[pack.Name].MemoryUsage = mu
	
end
function module:activateRightPack(bind)
	local packToActivate = nil
	local noPack = "|CFFFF3366No Packs avaiable|r for the selected Mouse Click.\nType |CFF99CCFF/LUI|r and configure Mouse Binding in the |CFF99CCFFAddons Manager Tab.|r"
	local currentActive = ""
	local currentLoaded = ""
	
	if db.profile.LUIAddons.AddonPacks then
		for k, v in pairs(db.profile.LUIAddons.AddonPacks) do 
			if (defaultMouseBindings[v.Binding]== bind) and (packToActivate == nil) then
				packToActivate = k
			end
			if v.Enabled == true then currentEnabled = k end
			if v.Loaded == true then currentLoaded = k end
		end
		--print(packToActivate)
		if packToActivate then
			
			-- LUI_Dynamics Integration
			if packToActivate == "Dynamics" then 
				if (IsAddOnLoaded("LUI_Dynamics")) then
					LUI.modules.Dynamics.dynamicsApply(true)
				end
			return 
			end
			
			if db.profile.LUIAddons.AddonPacks[packToActivate].Addons then
				if (db.profile.LUIAddons.AddonPacks[packToActivate].Modified or 
					(not db.profile.LUIAddons.AddonPacks[packToActivate].Loaded))
					 then
					
					-- All Pack's Addon Activation
					for i=1, #db.profile.LUIAddons.AddonPacks[packToActivate].Addons do
						local name = db.profile.LUIAddons.AddonPacks[packToActivate].Addons[i]
						if (CurrentInstalledAddons[name]) then 
							if not CurrentInstalledAddons[name].Enabled then module:LUIEnableAddon(CurrentInstalledAddons[name]) end
						end
					end
					-- All Not in Pack ADDons DeActivation
					local notInpack = module:notInPackAddons(packToActivate)
					for k,v in pairs(notInpack) do
						module:LUIDisableAddon(v)
					end
					
					print("|CFF99FF33Pack ".. packToActivate .. " will be activated on next UI Reload.|r")
					for k,v in pairs(db.profile.LUIAddons.AddonPacks) do
						if k==packToActivate then 
							v.Enabled = true
						else
							v.Enabled = false		
						end	
					end -- Set to Enable Current Pack and to Disabled all the others
					StaticPopup_Show("RELOAD_UI_ADDON")
					
				else
				 print("|CFF99FF33Pack ".. packToActivate .. " is already Active. No Action required.|r")
				end
			end
		else
			print(noPack)
		end
	else
		print(noPack)
	end
end
function module:storeAddonsInPack(newAddOnItemsArray)
	local array = {}
	if newAddOnItemsArray then
		for k,v in pairs(newAddOnItemsArray) do
			if v.Enabled then
				table.insert(array, v.Name)
			end
		end
	end
	return array -- IT contains all the Enabled Addons Names.
end
function module:notInPackAddons(pack)
	local array = {}
	for k,v in pairs(CurrentInstalledAddons) do
		local found = false
		for i=1, #db.profile.LUIAddons.AddonPacks[pack].Addons do
			local name = db.profile.LUIAddons.AddonPacks[pack].Addons[i]
			if v.Name == name then found = true end
		end
		if not found then
			array[v.Name] = v
		end
	end
	return array
end
function module:AddonEnabledInPack(pack,addon)
	local enabled = false
	for i=1, #db.profile.LUIAddons.AddonPacks[pack].Addons do
		local name = db.profile.LUIAddons.AddonPacks[pack].Addons[i]
		if name == addon then
			enabled = true
		end
	end
	return enabled
end
------------------------------------------------------
-- / ADD-ONS MANAGER INFOSTAT / --
------------------------------------------------------
local function NewStat(statDB)
	if InfoStats[statDB] then return InfoStats[statDB] end
	if db.profile[statDB] and not db.profile[statDB].Enable then return {Created = false} end
	local stat = CreateFrame("Frame", "LUI_Info_" .. statDB, LUI_Infos_TopRight) --TODO Change the Frame Position
	stat.db = statDB
	stat:EnableMouse(true)
	stat.Enable = function(stat)
		if stat.OnUpdate then
			stat.dt = 0
			stat:SetScript("OnUpdate", stat.OnUpdate)
			stat:OnUpdate(100)
		end
		if stat.Events then
			for i=1, #stat.Events do
				stat:RegisterEvent(stat.Events[i])
			end
			stat:SetScript("OnEvent", (type(stat.OnEvent) == "function" and stat.OnEvent or (function(self, event, ...) self[event](self, ...) end)))
		end
		if stat.OnEnter then
			stat:SetScript("OnEnter", stat.OnEnter)
		end
		if stat.OnLeave then
			stat:SetScript("OnLeave", stat.OnLeave)
		end
		if stat.OnClick then
			stat:SetScript("OnMouseDown", stat.OnClick)
		end
		if stat.OnEnable then stat:OnEnable() end
	end
	
	if db.profile[statDB] then
		module:NewText(stat)
		module:SetFontSettings(stat)
	end
	InfoStats[statDB] = stat
	return stat
end
function module:NewIcon(stat, tex)
	if not stat then return end
	if stat.icon then return stat.icon end
	
	local icon = CreateFrame("Button", stat:GetName().."Icon", stat)
	icon:SetPoint("RIGHT", stat.text, "LEFT", -2, 0)
	icon:SetWidth(15)
	icon:SetHeight(15)
	icon:SetFrameStrata("TOOLTIP")
	icon:SetBackdrop({bgFile = tex or "Interface\\Icons\\Spell_Nature_MoonKey", edgeFile = nil, tile = false, edgeSize = 0, insets = {top = 0, bottom, 0, left = 0, right = 0}})
	icon:Show()
	
	stat.icon = icon
end
function module:NewText(stat)
	if not stat then return end
	if stat.text then return stat.text end
	
	local fs = stat:CreateFontString(nil, "OVERLAY")
	fs:SetJustifyH("LEFT")
	fs:SetShadowColor(0, 0, 0)
	fs:SetShadowOffset(1.25, -1.25)
	
	stat.text = fs
	
	module:SetInfoPanel(stat)
end
function module:SetInfoPanel(stat)
	if type(stat) == "string" then stat = InfoStats[stat] end
	if not stat then return end
	
	local parent = _G["LUI_Infos_" .. db.profile[stat.db].InfoPanel.Vertical .. db.profile[stat.db].InfoPanel.Horizontal]
	
	stat.text:ClearAllPoints()
	stat.text:SetPoint(db.profile[stat.db].InfoPanel.Vertical, parent, db.profile[stat.db].InfoPanel.Vertical, db.profile[stat.db].X, db.profile[stat.db].Y)
	
	stat:SetParent(parent)
	stat:ClearAllPoints()
	stat:SetAllPoints(stat.text)
end
function module:SetFontSettings(stat)
	if type(stat) == "string" then stat = InfoStats[stat] end
	if not stat then return end
	
	stat.text:SetFont(LSM:Fetch("font", db.profile[stat.db].Font), db.profile[stat.db].FontSize, db.profile[stat.db].Outline)
	local color = db.profile[stat.db].Color
	stat.text:SetTextColor(color.r, color.g, color.b, color.a)
end
function module:UpdateTooltip(frame, func, ...)
	if frame:IsMouseOver() and GameTooltip:GetOwner() == frame then
		if func == nil then func = "OnEnter" end
		if type(func) == "function" then
			func(...)
		elseif type(func) == "string" and type(frame[func]) == "function" then
			if select("#", ...) == 0 then
				frame[func](frame)
			else
				frame[func](...)
			end
		end
	end
end
function module:ToggleStat(stat)
	if db.profile[stat] and not db.profile[stat].Enable then
		module:DisableStat(stat)
	else
		module:EnableStat(stat)
	end
end
function module:EnableStat(stat)
	module["Set"..stat]()
	if InfoStats[stat] then
		if InfoStats[stat].Created then
			if not InfoStats[stat].Hidden then InfoStats[stat]:Show() end
			InfoStats[stat]:Enable()
		else
			InfoStats[stat]:Hide()
		end
	end
end
function module:DisableStat(stat)
	if not InfoStats[stat] or not InfoStats[stat].Created then return end
	InfoStats[stat]:UnregisterAllEvents()
	InfoStats[stat]:SetScript("OnUpdate", nil)
	if InfoStats[stat].OnDisable then InfoStats[stat]:OnDisable() end
	InfoStats[stat]:Hide()
end
function module:ResetStat(stat)
	if not InfoStats[stat] or not InfoStats[stat].Created then return end
	if InfoStats[stat].text then
		module:SetInfoPanel(stat)
		module:SetFontSettings(stat)
	end
	if InfoStats[stat].OnReset then InfoStats[stat]:OnReset() end
	if InfoStats[stat].OnUpdate then InfoStats[stat]:OnUpdate(100) end
end
function module:copyDefaults(dest, src)
		for k, v in pairs(src) do
			if type(v) == "table" then
				if not rawget(dest, k) then rawset(dest, k, {}) end
				if type(dest[k]) == "table" then
					module:copyDefaults(dest[k], v)
				end
			else
				if rawget(dest, k) == nil then
					rawset(dest, k, v)
				end
			end
		end
	end
function module:getOwnerAnchor(frame)
	return (module:isTop(frame) and "ANCHOR_BOTTOM" or "ANCHOR_TOP")
end
function module:isTop(frame)
	if frame.db and db.profile[frame.db] then
		return (db.profile[frame.db].InfoPanel.Vertical == "Top")
	else
		return (select(2, frame:GetCenter()) > UIParent:GetHeight() / 2)
	end
end
	
local function SetInfoTextFrames()
	if not LUI_Infos_TopLeft then
		LUI:CreateMeAFrame("FRAME","LUI_Infos_TopLeft",UIParent,1,1,1,"HIGH",0,"TOPLEFT",UIParent,"TOPLEFT",0,-1,1)
	end
	LUI_Infos_TopLeft:SetAlpha(1)
	LUI_Infos_TopLeft:Show()
	
	if not LUI_Infos_TopRight then
		LUI:CreateMeAFrame("FRAME","LUI_Infos_TopRight",UIParent,1,1,1,"HIGH",0,"TOPRIGHT",UIParent,"TOPRIGHT",0,-1,1)
	end
	LUI_Infos_TopRight:SetAlpha(1)
	LUI_Infos_TopRight:Show()
	
	if not LUI_Infos_BottomLeft then
		LUI:CreateMeAFrame("FRAME","LUI_Infos_BottomLeft",UIParent,1,1,1,"HIGH",0,"BOTTOMLEFT",UIParent,"BOTTOMLEFT",0,4,1)
	end
	LUI_Infos_BottomLeft:SetAlpha(1)
	LUI_Infos_BottomLeft:Show()
	
	if not LUI_Infos_BottomRight then
		LUI:CreateMeAFrame("FRAME","LUI_Infos_BottomRight",UIParent,1,1,1,"HIGH",0,"BOTTOMRIGHT",UIParent,"BOTTOMRIGHT",0,4,1)
	end
	LUI_Infos_BottomRight:SetAlpha(1)
	LUI_Infos_BottomRight:Show()
end

function module:SetAddonSwitcher()
	local stat = NewStat("AddonSwitcher")
	if db.profile.AddonSwitcher.Enable and not stat.Created then
		module:NewIcon(stat)
		stat.icon:SetScript("OnMouseDown", function(self, button) -- OnMouseDown EVENT
			-- TODO INSERT CODE
		end)
		
		-- Localized functions
		local GetNumTalentGroups, GetActiveTalentGroup = GetNumTalentGroups, GetActiveTalentGroup
		local tonumber, tostring = tonumber, tostring
		
		-- Local variables
		local MAXADDONPACKS = 5
		local numPacks,text
		
		stat.OnClick = function(self, button)
			-- {"NONE", "Mouse1", "Mouse2", "Mouse3", "Mouse4", "Mouse5", 
					-- "CTRL+Mouse1","CTRL+Mouse2","CTRL+Mouse3","CTRL+Mouse4","CTRL+Mouse5",
					-- "SHIFT+Mouse1","SHIFT+Mouse2","SHIFT+Mouse3","SHIFT+Mouse4","SHIFT+Mouse5",
					-- "ALT+Mouse1","ALT+Mouse2","ALT+Mouse3","ALT+Mouse4","ALT+Mouse5",}
		
			local b= "NONE"
			if IsShiftKeyDown() then
				if button == "LeftButton" then b= "SHIFT+Mouse1"  end
				if button == "RightButton" then b= "SHIFT+Mouse2"  end
				if button == "MiddleButton" then b= "SHIFT+Mouse"  end
				if button == "Button4" then  b= "SHIFT+Mouse4" end
				if button == "Button5" then b= "SHIFT+Mouse5"  end
			elseif IsControlKeyDown() then
				if button == "LeftButton" then b= "CTRL+Mouse1"  end
				if button == "RightButton" then b= "CTRL+Mouse2"  end
				if button == "MiddleButton" then b= "CTRL+Mouse3" end
				if button == "Button4" then b= "CTRL+Mouse4"  end
				if button == "Button5" then b= "CTRL+Mouse5"  end
			elseif IsAltKeyDown() then
				if button == "LeftButton" then b= "ALT+Mouse1"  end
				if button == "RightButton" then b= "ALT+Mouse2"  end
				if button == "MiddleButton" then b= "ALT+Mouse3" end
				if button == "Button4" then b= "ALT+Mouse4"  end
				if button == "Button5" then b= "ALT+Mouse5"  end
			--	ChatFrame_OpenChat( "/specalias "..GetTalentText().." ", DEFAULT_CHAT_FRAME)
			elseif button == "LeftButton" then b= "Mouse1"
			elseif button == "RightButton" then b= "Mouse2"
			elseif button == "MiddleButton" then b= "Mouse3"
			elseif button == "Button4" then	b= "Mouse4"
			elseif button == "Button5" then	b= "Mouse5"
			end
			--print("Clicked Binding is : "..b)
			module:activateRightPack(b)
			
			end
		
		stat.OnEnter = function(self)
			GameTooltip:SetOwner(self, module:getOwnerAnchor(self))
			GameTooltip:ClearLines()
			currentPack = ""
			currentLoadedPack = ""
			currentMem = ""
			currentLoadedMem = ""
			numPacks = 0
			if db.profile.LUIAddons.AddonPacks then
				for k, v in pairs(db.profile.LUIAddons.AddonPacks) do 
					numPacks = numPacks + 1 
					if v.Enabled then
						currentPack = v.Name
						currentMem = formatMem(v.MemoryUsage)
					end
					if v.Loaded then
						currentLoadedPack = v.Name
						currentLoadedMem = formatMem(v.MemoryUsage)
					end
				end
			end
			
			GameTooltip:AddLine("LUI Add-Ons Switcher ".. version.." :", 0.4, 0.78, 1)
			GameTooltip:AddLine(" ")
			if not(currentPack == "") then 
				GameTooltip:AddLine("Active Pack : ".. currentLoadedPack.." ("..currentMem..")" , 0.4, 0.78, 1)
				GameTooltip:AddLine(" ")
			end
			if not (currentLoadedPack == currentPack) then
				GameTooltip:AddLine("Pack on Next RELOADUI : ".. currentPack.." ("..currentLoadedMem..")" , 0.4, 0.78, 1)
				GameTooltip:AddLine(" ")
			end
			if numPacks > 0 then
				for i=0,#defaultMouseBindings do
					for k, v in pairs(db.profile.LUIAddons.AddonPacks) do
						if v.Binding == i then
							GameTooltip:AddLine("|CFF99FF33"..v.Name .."|r  (".. v.Description..") - |CFFFF9900" ..defaultMouseBindings[v.Binding].."|r" )
						end
					end
				end
			else
				GameTooltip:AddLine("No Add-ons Packs created for this Character. ")
				GameTooltip:AddLine("Please click on the Icon to open the LUI Options and create Packs. ")
			end
			
			
			GameTooltip:AddLine(" ")
			GameTooltip:AddLine("Hint:\n- Click on the InfoText with the Assigned Mouse Button\n- to Load the Add-Ons Pack.", 0, 1, 0)
			GameTooltip:Show()
		
		end
		stat.OnLeave = function()
			GameTooltip:Hide()
		end
		
		
		text = "LUI Addons"
		if db.profile.LUIAddons.AddonPacks then
				for k, v in pairs(db.profile.LUIAddons.AddonPacks) do 
					if v.Loaded then
						text= v.Name
					end
				end
		end
		stat.text:SetText(text)
		
		stat.Created = true
	end
end

--------------------------------------------------
-- / MODULE HANDLING / --
--------------------------------------------------

module.order = 2.8
module.defaults = {
	profile = {
		DBConverted = false,
		Enabled = true,
		CurrentAddonPack = nil,	
		AddonPacks = {},
		AddonSwitcher = {
			Enable = true,
			X = -320,
			Y = 0,
			InfoPanel = {
				Horizontal = "Right",
				Vertical = "Bottom",
			},
			Font = "vibroceb",
			FontSize = 12,
			Outline = "NONE",
			Color = {
				r = 1,
				g = 1,
				b = 1,
				a = 1,
			},
		},
			
	},
}

-- Function to create AddonPacks Array List in Option Panel
local function createAddonPackOptions()
	
	local function getBindingValue(info)
		return db.profile.LUIAddons.AddonPacks[info[#info-1]][info[#info]] --TODO
	end
	local function setBindingValue(info, val)
		db.profile.LUIAddons.AddonPacks[info[#info-1]][info[#info]] = val
	end
	
	local function deletePack(info)
		
		db.profile.LUIAddons.AddonPacks[info[#info-1]].Addons = nil
		db.profile.LUIAddons.AddonPacks[info[#info-1]] = nil
		
		print("Successfully removed the Addon Pack |cff00ff33" .. info[#info-1] .. "|r from the Packs.")
		
		module:UpdateOptions()
		--module:ApplyTheme()
	end
	local function toggleAddonsList(info)
		if (db.profile.LUIAddons.AddonPacks[info[#info-1]].ShowDetails) then 
			db.profile.LUIAddons.AddonPacks[info[#info-1]].ShowDetails = false
		else
			db.profile.LUIAddons.AddonPacks[info[#info-1]].ShowDetails = true
		end
		module:UpdateOptions()
		
	end 
	local options = {}
	
	local x=0
	if db.profile.LUIAddons.AddonPacks and type(db.profile.LUIAddons.AddonPacks) == "table" then 
		for a,b in pairs(db.profile.LUIAddons.AddonPacks) do x=x+1 end
	end
	
	if db.profile.LUIAddons.AddonPacks and type(db.profile.LUIAddons.AddonPacks) == "table" and x >0 then
		for k, v in pairs(db.profile.LUIAddons.AddonPacks) do
			options[k] = {
				name = function() 
				local s=""
				if v.Enabled then 
					s="|CFF99FF00Pack: ".. db.profile.LUIAddons.AddonPacks[k].Name.. "|r"
				else
					s="|CFF993333Pack: ".. db.profile.LUIAddons.AddonPacks[k].Name.. "|r"
				end
				if not (v.MemoryUsage == nil or v.MemoryUsage ==0 or v.MemoryUsage =="") then
					s= s.. " (".. formatMem(v.MemoryUsage).." Used)"
				else
					s= s.. " (0mb until 1st activation)"
				end
				return s
				end,
				type = "group",
				guiInline = true,
				order = 10, -- sort alphabetically
				args = {
					AddonPackDesc = {
						name = "Addon Pack Description",
						desc = "A Description for the new Pack you're creating.",
						type = "input",
						width = "full",
						get = function() return db.profile.LUIAddons.AddonPacks[k].Description end,
						set = function(info, val) db.profile.LUIAddons.AddonPacks[k].Description = val module:UpdateOptions() end,
						order = 3
						},
					Binding = {
						name = "Mouse Binding",
						desc = "The Mouse Button you want to click on the INFOTEXT to Activate this Pack",
						type = "select",
						values = defaultMouseBindings,
						get = getBindingValue,
						set = setBindingValue,
						order = 2,
					},
					ShowDetails = {
						name = function() 
								local n
								if (db.profile.LUIAddons.AddonPacks[k].ShowDetails) then 
									n="Hide Add-Ons Details" 
								else 
									n="Show Add-Ons Details" 
								end
								return n
								end,
						desc = "Show Addons stored in this Pack",
						type = "execute",
						width = "full",
						func = toggleAddonsList,
						order = 5,
					},
					AddonPackInfos = {
						name = function() 
								local s=""
								if 	db.profile.LUIAddons.AddonPacks[k].ShowDetails then
									--if ShowDetails
										s="Loaded Addons : \n"
										local array = {}
										for i=1,#db.profile.LUIAddons.AddonPacks[k].Addons do
											table.insert(array, db.profile.LUIAddons.AddonPacks[k].Addons[i])
										end
										table.sort(array)
										if not (db.profile.LUIAddons.AddonPacks[k].MemoryUsage == 0) then
											-- IF Pack has MemoryUsage Details	
											for x=1,#array do
												n= array[x] 
												if CurrentInstalledAddons[n].Enabled then 
													s = s.. "- "..CurrentInstalledAddons[n].Title
													if not (CurrentInstalledAddons[n].MemoryUsed ==0) then
														local mem = CurrentInstalledAddons[n].MemoryUsed
														if mem < 100 then
															s = s .."(|CFF99FF66"..formatMem(mem).."|r)\n" --green
														elseif mem <1024 then
															s = s .."(|CFFFFFF33"..formatMem(mem).."|r)\n" -- yellow
														elseif mem <2048 then
															s = s .."(|CFFFF9933"..formatMem(mem).."|r)\n" -- orange
														else
															s = s .."(|CFFFF3333"..formatMem(mem).."|r)\n" -- red
														end
													else
														s= s.."(0kb)\n"
													end 
												end 
											end
										else
											-- IF Pack has no MemoryUsage Details
											for x=1,#array do
												n= array[x] 
												if CurrentInstalledAddons[n].Enabled then 
													s = s.. "- "..CurrentInstalledAddons[n].Title.. "\n" end 
											end	
										end
								else--if not ShowDetails
									local num = 0
									if db.profile.LUIAddons.AddonPacks[k].Addons then
										for i=1,#db.profile.LUIAddons.AddonPacks[k].Addons do
											if CurrentInstalledAddons[db.profile.LUIAddons.AddonPacks[k].Addons[i]] then
												if CurrentInstalledAddons[db.profile.LUIAddons.AddonPacks[k].Addons[i]].Enabled then num = num + 1 end
											end
										end	
										
									end
									s = num .. "/"..GetNumAddOns().." Add-Ons Enabled."
								end		
							return s 
							end,
						desc = "",
						type = "description",
						width ="full",
						order = 5,
						},	
					Delete = {
						name = "Delete",
						desc = "Delete this Addon Pack",
						type = "execute",
						width = "half",
						func = deletePack,
						order = 6,
					},
				}
			}
		end
	else 
		options["NoPacks"] = {
				name = "No Addon Packs Found",
				type = "group",
				order = 10,
				args={
					InfoNoPack = {
								name= "Please move to the Add an Add-on Pack Tab and create at least an add-ons Pack.",
								type= "description",
								order= 1,
								},
					}
		}
	end
	return options
end
local function createAddonListOptions(pack)
	
	local options = {}
	local x=0
	
	if pack == nil then pack="-" end
	if db.profile.LUIAddons.AddonPacks[pack] then 
		if db.profile.LUIAddons.AddonPacks[pack].Addons then x= #db.profile.LUIAddons.AddonPacks[pack].Addons end
	else
		if db.profile.LUIAddons.AddonPacks then
			for a,b in pairs(db.profile.LUIAddons.AddonPacks) do b.Selected = false end
		end
		options["NoAddons"] = {
				name = "No Addons saved in the Selected Pack",
				type = "description",
				order = 3,
		}
		return options
	end
	for k,v in pairs(CurrentInstalledAddons) do
		options[k] = 
			{
			name = v.Title,
			type = "toggle",
			desc = function () local s = "" 
							if v.Version then s = s.."Ver.".. v.Version end
							if v.Author then s = s.."\n |CFFFF9933Author:|r ".. v.Author.. "" end
							if v.Notes then s = s.."\n |cff00ff33Notes:|r ".. v.Notes .."" end
							if v.Dependencies then s = s.."\n |cff00ff33Dep.|r: ".. v.Dependencies.."" end
							--if v.Loadable then s = s.."\n |cff00ff33Loadable:|r Yes" else s = s.."\n |cff00ff33Loadable:|r No"  end
							--if v.LoD then s = s.."\n |cff00ff33LoD:|r Yes" else s = s.."\n |cff00ff33LoD:|r No"  end
							return s
							end,
			width = 100,
			get = function()
					local en = false
					if module:AddonEnabledInPack(pack,k) then
						en = true
					end
					return en 
				end,
			set = function(info, value)
						local currentEnabledState = module:AddonEnabledInPack(pack,k)
						if not (value == currentEnabledState) then
							if value then 
								table.insert(db.profile.LUIAddons.AddonPacks[pack].Addons,k)
							else
								local pos = 0
								for i=1, #db.profile.LUIAddons.AddonPacks[pack].Addons do
									local name = db.profile.LUIAddons.AddonPacks[pack].Addons[i]
									if name == k then pos = i end
								end
								table.remove(db.profile.LUIAddons.AddonPacks[pack].Addons,pos)
							end	
						end
						db.profile.LUIAddons.AddonPacks[pack].Modified = true
				end,
			order = 1,
			}
		end
	
	return options
end


function module:LoadOptions()
	local selectedPack
	local function clearAddPack()
		newAddonPack = {
			Name = "",
			Description = "",
			Binding = defaultMouseBindings[0],
			Enabled = true,
			Addons ={},
			Selected = false,
			MemoryUsage = 0,
			ShowDetails = false,
			Modified = false,
			Loaded = false,
			DBVersion = "",
		} 
	end
	local function addPack()
		if newAddonPack.Name == "" then
			return
		end

		if db.profile.LUIAddons.AddonPacks[newAddonPack.Name] then
			print("The Addon Pack |cff00ff33" .. newAddonPack.Name .. "|r already exists as an Addon Pack.")
			return
		end
		newAddonPack.DBVersion = "1.3"
		db.profile.LUIAddons.AddonPacks[newAddonPack.Name] = newAddonPack
		--db.profile.LUIAddons.AddonPacks[newAddonPack.Name].Addons = cloneTable(db.profile.LUIAddons.InstalledAddons)
		db.profile.LUIAddons.AddonPacks[newAddonPack.Name].Addons = self:storeAddonsInPack(CurrentInstalledAddons) -- 1.3
		print("Successfully added the Addon Pack |cff00ff33" .. newAddonPack.Name .. "|r to the Addon Packs List.")

		clearAddPack()
		
		self:UpdateOptions() --TODO
	end
	local function packGet()
		local pos
		local packNum=0
		if db.profile.LUIAddons.AddonPacks and type(db.profile.LUIAddons.AddonPacks) == "table" then 
			for a,b in pairs(db.profile.LUIAddons.AddonPacks) do packNum=packNum+1 end
		end
	
		for k,v in pairs(db.profile.LUIAddons.AddonPacks) do
			if v.Selected then
				local a = module:PacksArray()
				for i=0,#a do
					if k== a[i] then
						pos = i
					end
				end
			end
		end
		if pos == nil then
			pos = 1
		end
		--print("PackGet(1053) : pos = "..pos)
		return pos
	end 
	local function StatDisabled(info)
		for i, v in ipairs(info) do
			if v == module:GetName() then
				return not db.profile[info[i+1]].Enable
			end
		end
	end
	
	-- INFOTEXT Functions
	local fontflags = {"NONE", "OUTLINE", "THICKOUTLINE", "MONOCHROME"}
	local function NameLabel(info, statName) -- (info [, statName])
		statName = statName or info[#info]
		return (db.profile[statName].Enable and statName.. " InfoText" or ("|cff888888"..statName.." InfoText|r"))
	end
	local function PositionOptions(order, statName) -- (order [, statName])
		local horizontal = {"Left", "Right"}
		local vertical = {"Top", "Bottom"}
		
		local option = {
			name = "Info Panel and Position",
			type = "group",
			order = order,
			disabled = StatDisabled,
			guiInline = true,
			args = {
				X = {
					name = "X Offset",
					desc = function(info)
							return ("X offset for the " .. (statName or info[#info-2]) .. " info text.\n\n" ..
								"Note:\nPositive values = right\nNegative values = left\n" ..
								"Default: " .. db.defaults.profile[statName].X
							)
						end,
					type = "input",
					order = 1,
					disabled = function(info) return not db.profile[statName].Enable end,
					get = function(info) return tostring(db.profile[statName].X) end,
					set = function(info, value)
						if value == nil or value == "" then value = "0" end
						db.profile[statName].X = tonumber(value)
						module:SetInfoPanel(statName)
					end,
				},
				Y = {
					name = "Y Offset",
					desc = function(info)
							return ("Y offset for the " .. (statName or info[#info-2]) .. " info text.\n\n" ..
								"Note:\nPositive values = up\nNegative values = down\n" ..
								"Default: " .. db.defaults.profile[statName].Y
							)
						end,
					type = "input",
					order = 2,
					disabled = function(info) return not db.profile[statName].Enable end,
					get = function(info) return tostring(db.profile[statName].Y) end,
					set = function(info, value)
						if value == nil or value == "" then value = "0" end
						db.profile[statName].Y = tonumber(value)
						module:SetInfoPanel(statName)
					end,
				},
				Horizontal = {
					name = "Horizontal",
					desc = function(info)
							return ("Select the horizontal panel that the " .. (statName or info[#info-2]) .. " info text will be anchored to.\n\n" ..
								"Default: " .. db.defaults.profile[statName].InfoPanel.Horizontal
							)
						end,
					type = "select",
					disabled = function(info) return not db.profile[statName].Enable end,
					order = 3,
					values = horizontal,
					get = function(info)
						for k, v in pairs(horizontal) do
							if db.profile[statName].InfoPanel.Horizontal == v then return k end
						end
					end,
					set = function(info, value)
						db.profile[statName].InfoPanel.Horizontal = horizontal[value]
						db.profile[statName].X = 0
						module:SetInfoPanel(statName)
					end,
				},
				Vertical = {
					name = "Vertical",
					desc = function(info)
							return ("Select the vertical panel that the " .. (statName or info[#info-2]) .. " info text will be anchored to.\n\n" ..
								"Default: " .. db.defaults.profile[statName].InfoPanel.Vertical
							)
						end,
					type = "select",
					disabled = function(info) return not db.profile[statName].Enable end,
					order = 3,
					values = vertical,
					get = function(info)
						for k, v in pairs(vertical) do
							if db.profile[statName].InfoPanel.Vertical == v then return k end
						end
					end,
					set = function(info, value)
						db.profile[statName].InfoPanel.Vertical = vertical[value]
						db.profile[statName].Y = 0
						module:SetInfoPanel(statName)
					end,
				},
			}
		}
		
		return option
	end
	local function FontOptions(order, statName) -- (order [, statName])
	
	local option = {
			name = "Font Settings",
			type = "group",
			disabled = StatDisabled,
			order = order,
			guiInline = true,
			args = {
				FontSize = {
					name = "Size",
					desc = function(info)
							return ("Choose your " .. (statName or info[#info-2]) .. " info text's fontsize.\n\n" ..
								"Default: " .. db.defaults.profile[statName].FontSize
							)
						end,
					type = "range",
					disabled = function(info) return not db.profile[statName].Enable end,
					order = 1,
					min = 1,
					max = 40,
					step = 1,
					get = function(info) return db.profile[statName].FontSize end,
					set = function(info, value)
						db.profile[statName].FontSize = value
						module:SetFontSettings(statName)
					end,
				},
				Color = {
					name = "Color",
					desc = function(info)
							local defaults = db.defaults.profile[statName].Color
							return ("Choose your " .. statName .. " info text's colour.\n\n" ..
								"Defaults:\nr = " .. defaults.r .. "\ng = " .. defaults.g .. "\nb = " .. defaults.b .. "\na = " .. defaults.a
							)
						end,
					type = "color",
					hasAlpha = true,
					get = function(info)
							local color = db.profile[statName].Color
							return color.r, color.g, color.b, color.a
						end,
					set = function(info, r, g, b, a)
						local color = db.profile[statName].Color
						color.r = r
						color.g = g
						color.b = b
						color.a = a
						
						module:SetFontSettings(statName)
					end,
					disabled = function(info) return not db.profile[statName].Enable end,
					order = 2,
				},
				Font = {
					name = "Font",
					desc = function(info)
							return ("Choose your " .. (statName or info[#info-2]) .. " info text's font.\n\n" ..
								"Default: " .. db.defaults.profile[statName].Font
							)
						end,
					type = "select",
					dialogControl = "LSM30_Font",
					values = widgetLists.font,
					get = function(info) return db.profile[statName].Font end,
					set = function(info, value)
						db.profile[statName].Font = value
						module:SetFontSettings(statName)
					end,
					disabled = function(info) return not db.profile[statName].Enable end,
					order = 3,
				},
				Outline = {
					name = "Font Flag",
					desc = function(info)
							return ("Choose your " .. (statName or info[#info-2]) .. " info text's font flag.\n\n" ..
								"Default: " .. db.defaults.profile[statName].Outline
							)
						end,
					type = "select",
					values = fontflags,
					get = function(info)
						for k, v in pairs(fontflags) do
							if db.profile[statName].Outline == v then
								return k
							end
						end
					end,
					set = function(info, value)
						db.profile[statName].Outline = fontflags[value]
						module:SetFontSettings(statName)
					end,
					disabled = function(info) return not db.profile[statName].Enable end,
					order = 4,
				},
			},
		}

	return option
	end
	local function ResetOption(order)
		local option = {
			name = "Reset Settings",
			type = "execute",
			disabled = not db.profile["AddonSwitcher"].Enable,
			order = order,
			func = function(info)
				local statDB = "AddonSwitcher"
				
				for k, v in pairs(db.profile[statDB]) do
					db.profile[statDB][k] = nil
				end
				module:copyDefaults(db.profile[statDB], db.defaults.profile[statDB])
				db.profile[statDB].Enable = true
				
				module:ResetStat(statDB)
				module:DisableStat(statDB)
				module:EnableStat(statDB)
			end
		}
		
		return option
	end
	
	local options  = {
		AddAddonPack = {
			type = "group",
			order = 1,
			name = "Add an Add-on Pack",
			guiInline = false,
			args = {
				Title = {
					type = "header",
					order = 1,
					name = module:GetName() .. " - ".. version.. " by ".. author,
				},
				Info = {
					name = "",
					type = "group",
					guiInline = true,
					order = 2,
					args = {
						Description = {
							name = "LUI Addo-ons Manager allows you to create Addons Pack choosing for each one which addon you want to be loaded.",
							type = "description",
							order = 1,
						},
						PackExplanation = {
							name = "\n|cff3399ffNotice:|r You can create your preferred Addon Packs for questing, dungeons, raid or raid leading and switch quickly from one to another." ..
								"In this Tab you can create how many packs you want; then switch to the other tabs to customize them.",
							type = "description",
							order = 2,
						},
						NewAddonPackInfos = {
							name = "\n|cff3399ffNotice:|r When you create a |CFF99CC00new Addon Pack|r, the current loaded addons will be saved to that Set. Switch to the Confifure AddonSet Tab to "..
									"customize the addons that you want to be loaded for every single Pack.\n"..
									"In this Tab you can Create a new Pack or Copy a Pack from another LUI Character Profile.",
							type = "description",
							order = 3,
						},
					},
				},
				AddPack = {
					name = "Add a new Addon Pack",
					type = "group",
					guiInline = true,
					order = 3,
					args = {
						AddonPackName = {
							name = "Addon Pack Name",
							desc = "The name of the new Addon Pack you want to create. (Dynamics is a reserved name for integration with LUI_Dynamics Addon)",
							type = "input",
							get = function() return newAddonPack.Name end,
							set = function(info, val) newAddonPack.Name = val end,
							order = 1,
						},
						AddonPackDesc = {
							name = "Addon Pack Description",
							desc = "A Description for the new Pack you're creating.",
							type = "input",
							get = function() return newAddonPack.Description end,
							set = function(info, val) newAddonPack.Description = val end,
							order = 2,
						},
						Binding = {
							name = "Mouse Binding",
							desc = "Select the Mouse Button you want to click on the INFOTEXT to activate this Pack.",
							type = "select",
							width = "double",
							values = defaultMouseBindings,
							get = function() return newAddonPack.Binding end,
							set = function(info, val) newAddonPack.Binding = val end,
							order = 4,
						},
						Space = {
							name = "",
							type = "description",
							order = 5,
						},
						Add = {
							name = "Create Addon Pack",
							desc = "Add this Addon Pack to the list.",
							type = "execute",
							func = addPack,
							order = 6,
						},
						Clear = {
							name = "Clear",
							desc = "Clear the add New Pack Selection.",
							type = "execute",
							func = clearAddPack,
							order = 7,
						},
					},
				},
				Copy = {
					name = "Copy Add-Ons Packs from other Profiles",
					type = "group",
					guiInline = true,
					order = 4,
					disabled = false,
					args = {
						Profiles = {
								name = "Profiles",
								desc = "Select the LUI profile you want to copy",
								type = "select",
								values = module:LUIProfiles(),
								get = function(self,p) return profileToCopy end,
								set = function(self, p)
										local values = module:LUIProfiles()
										for k,v in pairs(db.profiles) do
											if k == values[p] then
												if k ~= "" then
													profileToCopy = p
												end
											end
										end
										module:UpdateOptions()
									end,
								order = 3,
							},
						Packs = {
								name = "Packs",
								desc = "Choose the Pack you want to copy",
								type = "select",
								values = module:LUIPacks(profileToCopy),
								get = function (self,p) return packToCopy end,
								set = function(self, p)
										local values =  module:LUIPacks(profileToCopy)
										local profiles = module:LUIProfiles()
										for k,v in pairs(db.profiles[profiles[profileToCopy]].LUIAddons.AddonPacks) do
											if k == values[p] then
												if k ~= "" then
													packToCopy = p
												end
											end
										end
										module:UpdateOptions()
									end,
								order = 4,
							},
						Button = {
							name = "Copy to ".. db.keys.profile,
							type = "execute",
							disabled = false,
							order = 5,
							func = function(info)
								local msg = ""
								if profileToCopy == "" or packToCopy == "" then
									msg = "|CFFFFCC00Select a profile and a Pack before to Copy!|r"
								else
									local packs =  module:LUIPacks(profileToCopy)
									local prof = module:LUIProfiles()
									if (db.profiles[prof[profileToCopy]].LUIAddons.AddonPacks[packs[packToCopy]].DBVersion) then
										if (db.profiles[prof[profileToCopy]].LUIAddons.AddonPacks[packs[packToCopy]].DBVersion == "2.0" )then
											newAddonPack = {
												Name = db.profiles[prof[profileToCopy]].LUIAddons.AddonPacks[packs[packToCopy]].Name,
												Description = db.profiles[prof[profileToCopy]].LUIAddons.AddonPacks[packs[packToCopy]].Description,
												Binding = db.profiles[prof[profileToCopy]].LUIAddons.AddonPacks[packs[packToCopy]].Binding,
												Enabled = false,
												Addons = {},
												Selected = false,
												MemoryUsage = db.profiles[prof[profileToCopy]].LUIAddons.AddonPacks[packs[packToCopy]].MemoryUsage,
												ShowDetails = false,
												Modified = false,
												Loaded = false, 
												DBVersion = "2.0",
												}
											if db.profile.LUIAddons.AddonPacks then
												for k,v in pairs(db.profile.LUIAddons.AddonPacks) do
													if newAddonPack.Name == v.Name then
														msg = "|CFFFFCC00The same pack already exist. Delete existing Pack before to copy it from another profile.|r"
													end
												end
											end
											
											if msg == "" then 
											
											db.profile.LUIAddons.AddonPacks[newAddonPack.Name] = newAddonPack
											db.profile.LUIAddons.AddonPacks[newAddonPack.Name].Addons = {}
											if (db.profiles[prof[profileToCopy]].LUIAddons.AddonPacks[packs[packToCopy]].Addons) then
												for i=1, #db.profiles[prof[profileToCopy]].LUIAddons.AddonPacks[packs[packToCopy]].Addons do
													local name = db.profiles[prof[profileToCopy]].LUIAddons.AddonPacks[packs[packToCopy]].Addons[i]
													table.insert(db.profile.LUIAddons.AddonPacks[newAddonPack.Name].Addons, name)
												end
											end
											
											msg ="|CFF99CCFF".. newAddonPack.Name .." Profile Successfully copied to profile ".. db.keys.profile.."|r"
											clearAddPack()
											module:UpdateOptions()
											end
										else msg = "|CFF99CCFF".. db.profiles[prof[profileToCopy]].LUIAddons.AddonPacks[packs[packToCopy]].Name ..
													" Profile Cannot be Copied 'cause DB Version is not 2.0! |r"
										end	
									else msg = "|CFF99CCFF".. db.profiles[prof[profileToCopy]].LUIAddons.AddonPacks[packs[packToCopy]].Name ..
												" Profile Cannot be Copied 'cause DB Version is not 2.0! |r"
									end
								end
								print (msg)
									
							end
						},
					},
		
		},
			},
		},
		ManageAddonPacks = {
			name = "Manage Addon Packs",
			type = "group",
			order = 2,
			args = createAddonPackOptions(),
		},
		ConfigureAddonsPacks = {
			name = "Configure Addon Packs",
			type = "group",
			order = 3,
			args = {
				Title = {
					type = "header",
					order = 1,
					name = "Choose the Addons for Every Pack",
				},
				Info = {
					name = "",
					type = "group",
					guiInline = true,
					order = 2,
					args = {
						Description = {
							name = function () 
								local s = ""
								if db.profile.LUIAddons.AddonPacks then
									for k, v in pairs(db.profile.LUIAddons.AddonPacks) do
										if v.Enabled then 
											s= s .. "|CFF99FF33Actual Activated Pack is : ".. v.Name .." ("..formatMem(v.MemoryUsage).." Used)|r\n"
										end
									end
									for k, v in pairs(db.profile.LUIAddons.AddonPacks) do
										if v.Selected then 
											s= s .. "\n|CFF99FF33You're modifing Pack : ".. v.Name .." ("..formatMem(v.MemoryUsage).." Used)|r\n"
										end
									end
								else
								if selectedPack and (not selectedPack == "") then
									s= s .. "|CFFFFFF00Actual Selected Pack is : ".. selectedPack .."|r\n"
								end
								s= s.. "|CFFFF3333No Actual Activated Pack!r\n"
								end
							s= s.. "This tab allows you to choose which addons will be loaded when you activate every single Addon Pack."
							 
							 return s
							 end,
							type = "description",
							order = 1,
						},
						PackExplanation = {
							name = "\n|cff3399ffNotice:|r 1st : Choose the Pack you want to |CFFFF9933edit|r in the dropdown menu below.\n" ..
								"Then click |CFF99CC00Current Pack Addon List in the LEFT box|r and you will be able to select the addons binded to the selected Pack.",
							type = "description",
							order = 2,
						},
						NewAddonPackInfos = {
							name = "\n|cff3399ffNotice:|r When you've finished to customize the current selected Pack, you can Click on |CFF99CC00Active Pack Selection|r and "..
									"click the |CFF99CC00Activate Current Pack Button|r to Enable the selected Pack.",
							type = "description",
							order = 3,
						},
					},
				},
				PackSelection = {
					name = "Active Pack Selection",
					type = "group",
					width = "full",
					order = 3,
					args = {
						Choose= {
							name = "Choose the Pack to Edit",
							type = "select",
							values = module:PacksArray(),
							get = packGet,
							set = function(self, PackSelection)
										local LUIPacksArray = module:PacksArray()
										for k,v in pairs(db.profile.LUIAddons.AddonPacks) do
											if k == LUIPacksArray[PackSelection] then
												if k ~= "-" then
													v.Selected = true
													selectedPack = k
													local mod = module:RefreshPack(selectedPack)
													if mod then print ("|cff3399ffSelected Pack has been modified; Check for new or deleted Add-Ons.|r") end
												end
											else
												v.Selected = false
											end
										end
										module:UpdateOptions(selectedPack)
									end,
							order = 1,
						},
						Activate = {
								name = "Activate Current Pack",
								desc = "Activate the selected Pack",
								type = "execute",
								disabled = function() return packGet() == 1 end,
								func = function() 
										if db.profile.LUIAddons.AddonPacks then
											if db.profile.LUIAddons.AddonPacks[selectedPack] then
													if db.profile.LUIAddons.AddonPacks[selectedPack].Addons then
														if (db.profile.LUIAddons.AddonPacks[selectedPack].Modified or (not db.profile.LUIAddons.AddonPacks[selectedPack].Loaded)) then
															-- All Pack's Addon Activation
															for i=1, #db.profile.LUIAddons.AddonPacks[selectedPack].Addons do
																local name = db.profile.LUIAddons.AddonPacks[selectedPack].Addons[i]
																if (CurrentInstalledAddons[name]) then 
																	if not CurrentInstalledAddons[name].Enabled then module:LUIEnableAddon(CurrentInstalledAddons[name]) end
																end
															end
															-- All Not in Pack ADDons DeActivation
															local notInpack = module:notInPackAddons(selectedPack)
															for k,v in pairs(notInpack) do
																module:LUIDisableAddon(v)
															end
															
															print("|CFF99FF33Pack ".. selectedPack .. " will be activated on next UI Reload.|r")
															for k,v in pairs(db.profile.LUIAddons.AddonPacks) do
																if k==selectedPack then 
																	v.Enabled = true
																else
																	v.Enabled = false		
																end	
															end -- Set to Enable Current Pack and to Disabled all the others
															module:UpdateOptions(selectedPack)
															StaticPopup_Show("RELOAD_UI_ADDON")
														else
														 print("|CFF99FF33Pack ".. selectedPack .. " is already Active. No Action required.|r")
														end
													end
											end
										end
										return
								end,
								order = 2,
							},
						EnableAll = {
								name = "Enable ALL",
								desc = "Enable all Addons for the Selected Pack",
								type = "execute",
								disabled = function() return packGet() == 1 end,
								func = function() 
									--print(selectedPack)
									if db.profile.LUIAddons.AddonPacks then
										if db.profile.LUIAddons.AddonPacks[selectedPack] then
											local adds = {}
											for k, v in pairs(CurrentInstalledAddons) do
												table.insert(adds,v.Name)
											end
											db.profile.LUIAddons.AddonPacks[selectedPack].Addons = adds
											print("Activated all Addons for Pack "..selectedPack)
											module:UpdateOptions(selectedPack)
										end
									end
									return
								end,
								order = 3,
							},
						DisableAll = {
								name = "Disable ALL",
								desc = "Disable all Addons for the Selected Pack",
								type = "execute",
								disabled = function() return packGet() == 1 end,
								func = function() 
									if db.profile.LUIAddons.AddonPacks then
										if db.profile.LUIAddons.AddonPacks[selectedPack] then
											db.profile.LUIAddons.AddonPacks[selectedPack].Addons = {}
											print("Deactivated all Addons for Pack "..selectedPack)
											module:UpdateOptions(selectedPack)
										end
									end
									return
								end,
								
								--DisableAllPack(selectedPack),
								order = 4,
							},
					},
				
				},
				AddonsList = {
					name = selectedPack or "Addon List",--"Current Pack Addon List",
					type = "group",
					order = 4,
					args = createAddonListOptions(selectedPack),
				},
		},
					
		},
		InfoText = {
			name = function(info) return NameLabel(info, "AddonSwitcher") end,
			type = "group",
			order = 4,
			disabled = false,
			args = {
				Header = {
					name = "Add-ons Switcher InfoText",
					type = "header",
					order = 1,
				},
				Enable = {
					name = "Enable",
					desc = "Whether you want to show the Add-ons Switcher InfoText or not.",
					type = "toggle",
					width = "full",
					get = function() return db.profile.AddonSwitcher.Enable or false end,
					set = function(info, value)
						db.profile.AddonSwitcher.Enable = value
						module:ToggleStat("AddonSwitcher")
					end,
					order = 2,
				},
				Position = PositionOptions(4, "AddonSwitcher"),
				Font = FontOptions(5, "AddonSwitcher"),
				Reset = ResetOption(6),
			},
		},
		-- ChangePacks = {
			-- name = "Manage Packs",
			-- type = "group",
			-- order = 5,
			-- disabled = false,
			-- 
		-- },
	}
	return options
end

function module:UpdateOptions(currentPack)
	LUI.options.args[self:GetName()].args.ManageAddonPacks.args = createAddonPackOptions()
	LUI.options.args[self:GetName()].args.ConfigureAddonsPacks.args["PackSelection"].args["Choose"].values = module:PacksArray()
	LUI.options.args[self:GetName()].args.ConfigureAddonsPacks.args["AddonsList"].args = createAddonListOptions(currentPack)
	LUI.options.args[self:GetName()].args.AddAddonPack.args["Copy"].args["Packs"].values = module:LUIPacks(profileToCopy)
	
	collectgarbage("collect") -- Clear the Memory Garbage
	
	LibStub("AceConfig-3.0"):RegisterOptionsTable("LUI", LUI.options)
	LibStub("AceConfigRegistry-3.0"):NotifyChange("LUI")
end

function module:OnInitialize()
	db = LUI:NewNamespace(self, true)
	db.profile.LUIAddons = db.profile.LUIAddons or {}
	db.profile.LUIAddons.version = db.profile.LUIAddons.version or 0
	-- if floor(db.profile.LUIAddons.version) ~= floor(version) then
		-- self:ResetDB()
		-- db.profile.LUIAddons.version = version
	-- end
	db.profile.LUIAddons.AddonPacks = db.profile.LUIAddons.AddonPacks or {}
	CurrentInstalledAddons = self:LUI_InstalledAddons() -- 1.3
	for k,v in pairs(db.profile.LUIAddons.AddonPacks) do
		if v.Enabled then 
			self:storeMemoryUsage(v)
			v.Loaded = true
		else
			v.Loaded = false
		end	
		v.Modified = false
		
	end  -- Loaded and Modified Flags Mechanic
	
	------------------------------------------------------ DB Conversion from 1.2 to 1.3 -------------------------------------------
	for k,v in pairs(db.profile.LUIAddons.AddonPacks) do
		if not (v.DBVersion == "2.0") then 
			local array = {}
			if v.Addons then
				for x,y in pairs(v.Addons) do
					if y.Enabled then
						table.insert(array,y.Name)
					end
				end
			end
			v.DBVersion = "2.0"
			v.Addons = array
			print ("Pack ".. k.." Converted to 2.0 DB.")
		end
	end
	if (db.profile.LUIAddons.InstalledAddons) then db.profile.LUIAddons.InstalledAddons = {} end -- Deleting OLD Installed Addons DB
	if (db.profile.LUI_Addons) then db.profile.LUI_Addons = {} end -- Deleting OLD Packs Addons 
	-- If you need to RESET all the DB Settings or only PAcks Settings : 
	--db.profile.LUIAddons = {} -- RESET ALL DB
	--db.profile.LUIAddons.AddonPacks = nil  RESET ALL PACKS for the Current Character
end

function module:OnEnable()
	SetInfoTextFrames()
	module:EnableStat("AddonSwitcher")
end

function module:OnDisable()
	module:DisableStat("AddonSwitcher")
end